#include <bcm2835.h>
#include <stdio.h>
#include "ssd1320.h"
#define WIDTH 128/2
#define HEIGHT 72


#define RST 25
#define DC  24


void er_oled_command(char cmd) {
    bcm2835_gpio_write(DC, LOW);
    bcm2835_spi_transfer(cmd);
}

void er_oled_data(char dat) {
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfer(dat);
}

void er_oled_begin()
{
    bcm2835_gpio_fsel(RST, BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(DC, BCM2835_GPIO_FSEL_OUTP);

    bcm2835_spi_begin();
    bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);     //The default
    bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                  //The default
    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_2048);  //The default
    bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                     //The default
    bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);     //the default

    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, LOW);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, HIGH);

 
 er_oled_command(0xae);//Set y Off
  er_oled_command(0xD5);//Set Display Clock Divide Ratio/Oscillator Frequency
  er_oled_command(0x11); 
  er_oled_command(0xA8);//Set Multiplex Ratio 
  er_oled_command(0x47); 
  er_oled_command(0xA2);//Set Display Start Line
  er_oled_command(0x00); 


  er_oled_command(0xD3);//Set Display Offset
  er_oled_command(0x74);
  er_oled_command(0xa1);//Set COM Output Scan Direction
  er_oled_command(0xC0); 
	
	
	
  er_oled_command(0xDA);//SetSEGPinsHardwareConfiguration
  er_oled_command(0x32);
	

  er_oled_command(0x81);//Set Contrast Control
  er_oled_command(0xdf);

  er_oled_command(0xD9);//SSet Pre-Charge Priod
  er_oled_command(0x72);
  er_oled_command(0xDB);//Set VCOMH Deselect Level 
  er_oled_command(0x20);
	
	
  er_oled_command(0xAD);//Set Internal IREF Enable
  er_oled_command(0x00);
  er_oled_command(0xBC);
  er_oled_command(0x1E); 
	
  er_oled_command(0xA4);//Set Entire Display On/Off
  er_oled_command(0xA6);
  er_oled_command(0xaf);//Display on  

  

}




void OLED_ColorTurn(uint8_t i)
{
	if(i==0)
		{
		er_oled_command(0xA6);
		}
	if(i==1)
		{
		er_oled_command(0xA7);
		}

}

void er_oled_SetWindow(uint8_t Xstart, uint8_t Ystart, uint8_t Xend, uint8_t Yend)
{ 
 
  er_oled_command(0x21);
  er_oled_command(Xstart);
  er_oled_command(Xend);
  er_oled_command(0x22);
  er_oled_command(Ystart);
  er_oled_command(Yend);
}

void er_oled_clear()
{int i,row;
  

  er_oled_SetWindow(0, 0, WIDTH-1, HEIGHT-1);
  for (row = 0; row < HEIGHT; row++) {              
        for(i = 0; i< WIDTH; i++ ) {
          er_oled_data(0x00);// write data       
        }        
  }
}


void er_oled_bitmap(const uint8_t * pBuf)
{   uint8_t row,col; 
  er_oled_SetWindow(0, 0, WIDTH-1, HEIGHT-1);
  for (row = 0; row < HEIGHT; row++) {              
        for(col = 0;col<WIDTH; col++ ) {
	er_oled_data(pBuf[col+row*WIDTH]);     
        }
  }    	
}


